/*
 * Copyright (C) 2014 Android LobbyPhone(TCC8935) Project
 *
 * FileName : Request_device_bootup.java
 * Project : Android LobbyPhone(TCC8935) Project
 * Company : HDC I-CONTROLS ( www.icontrols.co.kr )
 * Author : Jeffrey Nam
 * E-mail : jeffnam0524@gmail.com, cwnam@icontrols.co.kr
 * Date : 2014.11.18
 */

package kr.co.icontrols.ilp300_700.imap;

import android.content.Context;
import android.util.Log;

import kr.co.icontrols.ilp300_700.ethernet.SendNWaitMSG;
import kr.co.icontrols.ilp300_700.ethernet.SendNWaitMSG_NonSSL;
import kr.co.icontrols.ilp300_700.ethernet.iMAPCommon.iMAPResult;

public class Request_verify_access_authorization extends SendNWaitMSG_NonSSL {

    String TAG = "Request_verify_access_authorization";

    boolean bLOG = true;   // true, false
    boolean bLOG_DEBUG = false;   // true, false
    boolean bLOG_INFO = true;   // true, false
    Context mContext;
    iMAPResult miMAPResult;
    iMAPResultCtrl miMAPResultCtrl;
    int nNonEncryptedTargetPort = 10000;
    int nEncryptedTargetPort = 11000;
    int nTargetPort = nNonEncryptedTargetPort;
    public Request_verify_access_authorization(Context context) {
        LOG_INFO("[Request_verify_access_authorization] === START ===");
        mContext = context;
//        if (ConfigValue.eMainServerType == SetValue.Server2dot0_Integrated)
//            nTargetPort = nEncryptedTargetPort;
    }

    private void LOG(String log) {
        if (bLOG) Log.v(TAG, log);
    }

    private void LOG_DEBUG(String log) {
        if (bLOG_DEBUG) Log.d(TAG, log);
    }

    private void LOG_INFO(String log) {
        if (bLOG_INFO) Log.i(TAG, log);
    }

    public boolean send_verify_access_authorization_request(String strDevice, String strID, String strRecogType, String strOwner, int nDataLength, String strRecogData, String strMessage) {
        try {
            LOG_INFO("[send_verify_access_authorization_request] ===== START =====");
            return sendNwaitMSG("10.0.1.10", nTargetPort, MakeiMAPMSG.makeRequest_verify_access_authorization(strDevice, strID, strRecogType, strOwner, nDataLength, strRecogData, strMessage));
        } catch (Exception e) {
            Log.e(TAG, "[Exception] send_verify_access_authorization_request(String strDevice, String strID, String strRecogType, String strOwner, int nDataLength, String strRecogData, String strMessage)");
            e.printStackTrace();
            return false;
        }
    }

    @Override
    protected void onProcessDoing() {
        LOG_INFO("[onProcessDoing] ===== START =====");
    }

    @Override
    protected void onProcessDone(iMAPResult eResult) {
        try {
            LOG_INFO("[onProcessDone] eResult = " + eResult);
            if (eResult == iMAPResult.RcvDone) {
                if (DocMsg != null) {
                    setItem("service");
                    String strResult = getAttributeValue(0, "result");
                    if (strResult != null) {
                        if (strResult.equalsIgnoreCase("ok")) {
                            if ((getAttributeValue(0, "name").equalsIgnoreCase("verify_access_authorization")) && (getAttributeValue(0, "type").equalsIgnoreCase("reply"))) {
                                miMAPResultCtrl.onResult(iMAPResult.OK);
                                return;
                            } else {
                                miMAPResultCtrl.onResult(iMAPResult.ReplyIsNotMatchWithRequest);
                                return;
                            }
                        } else if (strResult.equalsIgnoreCase("fail")) {
                            miMAPResultCtrl.onResult(iMAPResult.ResultFail);
                            return;
                        } else {
                            miMAPResultCtrl.onResult(iMAPResult.UnexpectedReply);
                            return;
                        }
                    } else {
                        miMAPResultCtrl.onResult(iMAPResult.ReplyHasFault);
                        return;
                    }
                } else {
                    miMAPResultCtrl.onResult(iMAPResult.ReplyHasNoContents);
                    return;
                }
            } else {
                miMAPResultCtrl.onResult(eResult);
                return;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onProcessDone(eResult)");
            e.printStackTrace();
        }
    }

    public void setResultCtrl(iMAPResultCtrl eResult) {
        try {
            miMAPResultCtrl = eResult;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] setResultCtrl(eResult)");
            e.printStackTrace();
        }
    }


}